## qwlroots 0.2.0-alpha2+git+20240808

=== debian/changelog ===
qwlroots (0.2.0-alpha2+git+20240808-deepin) unstable; urgency=medium

 * Sync upstream code

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Thu, 08 Aug 2024 10:42:06 +0800

qwlroots (0.2.0-alpha2+git+20240626-deepin) unstable; urgency=medium

 * Sync upstream code

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Wed, 26 Jun 2024 18:42:06 +0800

qwlroots (0.2.0-alpha2) unstable; urgency=medium

    * Sync upstream code

   -- Dingyuan Zhang <zhangdingyuan@deepin.org>  Thu, 20 Jun 2024 19:00:53 +0800

qwlroots (0.2.0-alpha1) unstable; urgency=medium

    * Sync upstream code

   -- Dingyuan Zhang <zhangdingyuan@deepin.org>  Tue, 28 May 2024 13:07:53 +0800

qwlroots (0.0+git20231208-0deepin) UNSTABLE; urgency=medium

  * fix build with wlroots 0.17.0

 -- rewine <luhongxu@deepin.org>  Fri, 24 Nov 2023 17:28:54 +0800

qwlroots (0.0+git20231027-0deepin) UNSTABLE; urgency=medium

  * Continuous release.

 -- rewine <rewine@beige.nixos>  Fri, 27 Oct 2023 03:02:40 +0000

qwlroots (0.0+git20231016-0deepin) UNSTABLE; urgency=medium

  * Initial continuous release

 -- rewine <lhongxu@outlook.com>  Wed, 19 Jul 2023 03:36:12 +0000
