## qwlroots 0.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,8 @@
 option(PREFER_QT_5 "Prefer to use Qt 5 even if we have Qt 6" OFF)
 option(USE_WLROOTS_GIT "Use wlroots git version" OFF)
 option(QWLROOTS_USE_PERCOMPILE_HEADERS "Use precompile headers to build qwlroots" OFF)
+option(DISABLE_WLR_PROTOCOLS "Disable support for wlr protocols, such as wlr-layer-shell" OFF)
+option(DISABLE_XWAYLAND "Disable the xwayland support" OFF)
 
 if(PREFER_QT_5)
     find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core)
