## qwlroots 0.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.21)
 
 project(QWlroots
-    VERSION 0.0.1
+    VERSION 0.5.3
     LANGUAGES CXX C)
 
 set(CMAKE_CXX_STANDARD 20)
@@ -14,6 +14,7 @@
 
 option(PREFER_QT_5 "Prefer to use Qt 5 even if we have Qt 6" OFF)
 option(USE_WLROOTS_GIT "Use wlroots git version" OFF)
+option(USE_WLROOTS_17 "Use wlroots 0.17 version" OFF)
 option(QWLROOTS_USE_PERCOMPILE_HEADERS "Use precompile headers to build qwlroots" OFF)
 option(DISABLE_WLR_PROTOCOLS "Disable support for wlr protocols, such as wlr-layer-shell" OFF)
 option(DISABLE_XWAYLAND "Disable the xwayland support" OFF)
